//____________________________________________________________
//    WaitSpeech.c
//
//    Copyright  Dan Parks Sydow, 1995
//    From the book:
//    "Graphics and Sound Programming Techniques for the Mac",
//    M&T Books, 1995


//____________________________________________________________

#include <Gestalt.h>
#include <Speech.h>


//____________________________________________________________

void     InitializeToolbox( void );
Boolean  IsSpeechAvailable( void );


//____________________________________________________________

void  main( void )
{ 
   Str255   theString = "\pThis is the second string";
   OSErr    theError;
   Boolean  speechPresent;
   
   InitializeToolbox();

   speechPresent = IsSpeechAvailable();
   if ( speechPresent == false )
      ExitToShell();

   theError = SpeakString( "\pThis is string #1" );
   if ( theError != noErr )
      ExitToShell();

   while ( SpeechBusy() == true )
      ;
      
   theError = SpeakString( theString );
   if ( theError != noErr )
      ExitToShell();
      
   // ** if you don't hear the second string of speech on your Mac,     **
   // ** uncomment the following two lines and recompile. Some Macs     **
   // ** exit before speech completes, some don't. In your apps, you'll **
   // ** want to include the following lines after each call to         **
   // ** to SpeakString() to ensure that speech completes.              **
   
//   while ( SpeechBusy() == true )
//      ;

}


//____________________________________________________________

Boolean  IsSpeechAvailable( void )
{
   OSErr    theError;
   long     theResult;
   Boolean  speechAvail;
   
   theError = Gestalt( gestaltSpeechAttr, &theResult );
   if ( theError != noErr )
      ExitToShell();
      
   speechAvail = theResult & ( 1 << gestaltSpeechMgrPresent );  
   if ( speechAvail > 0 )
      return ( true );
   else
      return ( false );
}


//____________________________________________________________

void  InitializeToolbox( void )
{
   InitGraf( &qd.thePort );
   InitFonts();
   InitWindows();
   InitMenus();
   TEInit();
   InitDialogs( 0L );
   FlushEvents( everyEvent, 0 );
   InitCursor();
}



