//____________________________________________________________
//    EditMenu.c
//
//    Copyright  Dan Parks Sydow, 1995
//    From the book:
//    "Graphics and Sound Programming Techniques for the Mac",
//    M&T Books, 1995


//____________________________________________________________

#include <Movies.h>

#include "Defines.h" 
#include "DataTypes.h"
#include "Globals.h"
#include "WindRecordAccess.h"
#include "EditMenu.h"


//____________________________________________________________

void  HandleEditMenuUndoItem( void )
{
   WindowPtr        theWindow;
   MovieController  theController;

   theWindow = FrontWindow();
   theController = GetWindowController( theWindow );
   
   MCUndo( theController );
}


//____________________________________________________________

void  HandleEditMenuCutItem( void )
{
   WindowPtr        theWindow;
   MovieController  theController;
   Movie            theTempMovie;

   theWindow = FrontWindow();
   theController = GetWindowController( theWindow );
   
   theTempMovie = MCCut( theController );
   PutMovieOnScrap( theTempMovie, movieScrapOnlyPutMovie );
   DisposeMovie( theTempMovie );    
}


//____________________________________________________________

void  HandleEditMenuCopyItem( void )
{
   WindowPtr        theWindow;
   MovieController  theController;
   Movie            theTempMovie;

   theWindow = FrontWindow();
   theController = GetWindowController( theWindow );
   
   theTempMovie = MCCopy( theController );
   PutMovieOnScrap( theTempMovie, movieScrapOnlyPutMovie );
   DisposeMovie( theTempMovie );    
}


//____________________________________________________________

void  HandleEditMenuPasteItem( void )
{
   WindowPtr        theWindow;
   MovieController  theController;

   theWindow = FrontWindow();
   theController = GetWindowController( theWindow );
   
   MCPaste( theController, nil );
}


//____________________________________________________________

void  HandleEditMenuClearItem( void )
{
   WindowPtr        theWindow;
   MovieController  theController;

   theWindow = FrontWindow();
   theController = GetWindowController( theWindow );
   
   MCClear( theController );
}


//____________________________________________________________

void  HandleEditMenuSelectAllItem( void )
{
   WindowPtr        theWindow;
   MovieController  theController;
   TimeRecord       theTimeRecord;
   Movie            theMovie;

   theWindow = FrontWindow();
   theController = GetWindowController( theWindow );   
   theMovie = GetWindowMovie( theWindow );
   		
   theTimeRecord.value.hi = 0; 
   theTimeRecord.value.lo = 0;
   theTimeRecord.base = 0;
	
   theTimeRecord.scale = GetMovieTimeScale( theMovie );	
   MCDoAction( theController, mcActionSetSelectionBegin, &theTimeRecord);
	
   theTimeRecord.value.lo = GetMovieDuration( theMovie );	
   MCDoAction( theController, mcActionSetSelectionDuration, &theTimeRecord );
}
