 
//____________________________________________________________
//    PickAndPlay.c
//
//    Copyright  Dan Parks Sydow, 1995
//    From the book:
//    "Graphics and Sound Programming Techniques for the Mac",
//    M&T Books, 1995


//____________________________________________________________

#include <QuickTimeComponents.h>


//____________________________________________________________

void  InitializeToolbox( void );
void  InitializeInstrument( long );
void  PlayMusicFromNoteChannel( void );


//____________________________________________________________

#define      kMIDInoInstrument       0


//____________________________________________________________

NoteAllocator    gNoteAllocatorComp;
ToneDescription  gToneDesc;


//____________________________________________________________

void  main( void )
{
   ComponentResult  theResult;
   Str31            thePrompt = "\pSelect an instrument:";
   long             theInstrument = kMIDInoInstrument;

   InitializeToolbox();

   InitializeInstrument( theInstrument );

   theResult = NAPickInstrument( gNoteAllocatorComp, nil, thePrompt, 
                                 &gToneDesc, 0, 0, 0, 0 );

   if ( ( gToneDesc.instrumentNumber == 0 ) || ( theResult != noErr ) )
      ExitToShell();
   else
      PlayMusicFromNoteChannel();
}


//____________________________________________________________

void InitializeInstrument( long theInstrument )
{
   ComponentResult  theResult;

   gNoteAllocatorComp = OpenDefaultComponent( kNoteAllocatorType, 0 );

   theResult = NAStuffToneDescription( gNoteAllocatorComp, theInstrument, &gToneDesc );
}


//____________________________________________________________

void  PlayMusicFromNoteChannel( void )
{
   NoteRequest     theNoteRequest;
   NoteChannel     theNoteChannel;
   short           thePitch;
   ComponentResult theError;
   long            theLong;

   theNoteRequest.polyphony = 4;
   theNoteRequest.typicalPolyphony = 0x00010000;
   theNoteRequest.tone = gToneDesc;

   theError = NANewNoteChannel( gNoteAllocatorComp, &theNoteRequest, &theNoteChannel );

   for ( thePitch = 36; thePitch <= 96; thePitch++ )
   {
      NAPlayNote( gNoteAllocatorComp, theNoteChannel, thePitch, 127 );
      Delay( 10, &theLong );
      NAPlayNote( gNoteAllocatorComp, theNoteChannel, thePitch, 0 );
   }

   theError = NADisposeNoteChannel( gNoteAllocatorComp, theNoteChannel );
}


//____________________________________________________________

void  InitializeToolbox( void )
{
   InitGraf( &qd.thePort );
   InitFonts();
   InitWindows();
   InitMenus();
   TEInit();
   InitDialogs( 0L );
   FlushEvents( everyEvent, 0 );
   InitCursor();
}
